<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	require_once GEKKO_ROOT."modules/gallery/main.lib.php";

	$action = _ext("action", 2);
	$id = _ext("id", 3);

	switch ($action) {
		case "item":
			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/gallery.admin.tpl");
			$tpl->insert("ITEM.FORM", "gallery/item.form.tpl");

			$db->query("SELECT ID, GalleryLink, Title, Description,
			Thumbnail, ThumbnailSize, MediaURL, MediaSize, AuthorID,
			LastUpdated, CreationTime, AllowComments
			FROM ".db_table("gallery_item")." WHERE ID = '$id'", __FILE__, __LINE__);

			$row = $db->fetch_row();

			$tpl->set_arr($row);

			$db->query("SELECT Title FROM ".db_table("gallery")." WHERE ID = '{$row["GalleryLink"]}'", __FILE__, __LINE__);
			$row2 = $db->fetch_row();

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => $row2["Title"],
					"BLOCK_SUBTITLE" => _l("L_EDIT_ITEM"),
					"BLOCK_ICON" => mkIcon("gallery.png", 16),
					"GALLERIES.SEL" => mkSelect(getGalleries(false), $row["GalleryLink"], "gallerylink"),
					"ACTION" => "edit_item",
					"OPTIONS" => mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), $row["AllowComments"]),
					"ITEMS" => 0,
					"RETURN" => ""
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "items":

			$page = _ext("page", 4);

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/gallery.admin.tpl");
			$tpl->insert("ITEM.FORM", "gallery/item.form.tpl");

			$pager = $db->pager (
				"SELECT ID FROM ".db_table("gallery_item")." WHERE GalleryLink = '{$id}'",
				"index.php/admin/gallery/items/{$id}/%p#items", $page, conf::getkey("gallery", "items_per_admin_page")
			);

			$db->query("SELECT ID, Title, Description, Thumbnail, ThumbnailSize,
			MediaURL, AllowComments, LastUpdated, AuthorID
			FROM ".db_table("gallery_item")." WHERE
			GalleryLink = '{$id}' ORDER BY Title ASC ".$pager["sql"]."", __FILE__, __LINE__);

			$items = $db->num_rows();

			while ($row = $db->fetch_row()) {

				$thumbsize = explode("x", $row["ThumbnailSize"]);
				$row["THUMBNAIL.WIDTH"] = $thumbsize[0];
				$row["THUMBNAIL.HEIGHT"] = $thumbsize[1];

				$row["AUTHOR"] = getUserById($row["AuthorID"]);
				$row["MODIFIED"] = dateFormat($row["LastUpdated"]);
				$row["ACTIONS"] = mkButtonDisplay (
					Array (
						mkLink("index.php/admin/gallery/item/".$row["ID"], _l("L_EDIT")),
						mkLink("modules/gallery/main.act.php?action=delete_item&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1),
					)
				);
				$tpl->set_arr($row, "ITEM");
				$tpl->saveBuff("ITEM");
			}

			$db->query("SELECT Title FROM ".db_table("gallery")." WHERE ID = '{$id}'", __FILE__, __LINE__);
			$row = $db->fetch_row();

			$tpl->set_arr (
				Array (
					"BLOCK_TITLE" => $row["Title"],
					"BLOCK_SUBTITLE" => _l("L_ADD_ITEM"),
					"BLOCK_ICON" => mkIcon("gallery.png", 16),
					"GALLERIES.SEL" => mkSelect(getGalleries(false), $id, "gallerylink"),
					"TITLE" => "",
					"ACTION" => "add_item",
					"DESCRIPTION" => "",
					"ITEMS" => $items,
					"PAGER" => $pager["html"],
					"OPTIONS" => mkCheckBox("allowcomments", _l("L_ALLOW_COMMENTS"), 1),
					"RETURN" => ""
				)
			);

			$mcBuff = $tpl->make();
		break;
		case "edit":

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/index.admin.tpl");
			$tpl->insert("GALLERY.FORM", "gallery/gallery.form.tpl");

			// fetching associated galleries
			$db->query("SELECT
			ID, Title, Description, Status, Thumbnail, ThumbnailSize, AuthorID,
			LastUpdated
			FROM ".db_table("gallery")."
			WHERE GalleryLink = '{$id}'", __FILE__, __LINE__);
			$galleries = $db->num_rows();
			while ($row = $db->fetch_row()) {
				$thumbsize = explode("x", $row["ThumbnailSize"]);
				$row["THUMBNAIL.WIDTH"] = $thumbsize[0];
				$row["THUMBNAIL.HEIGHT"] = $thumbsize[1];
				$row["AUTHOR"] = getUserById($row["AuthorID"]);
				$row["MODIFIED"] = dateFormat($row["LastUpdated"]);
				$row["ITEMS"] = countItems($row["ID"]);
				$row["SUBGALLERIES"] = "-";
				$row["ACTIONS"] = mkButtonDisplay (
					Array (
						mkLink("index.php/admin/gallery/edit/".$row["ID"], _l("L_EDIT")),
						mkLink("modules/gallery/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1),
						mkLink("modules/gallery/main.act.php?action=".($row["Status"] ? "disable" : "enable")."&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_".($row["Status"] ? "DISABLED" : "ENABLED").""))
					)
				);
				$tpl->set_arr($row, "GALLERY");
				$tpl->saveBuff("GALLERY");
			}

			$db->query("SELECT
			ID, GalleryLink, Title, Description, Status, Thumbnail,
			ThumbnailSize, AuthorID, LastUpdated, auth_Access
			FROM ".db_table("gallery")." WHERE ID = '{$id}'
			", __FILE__, __LINE__);

			$row = $db->fetch_row();
			$thumbsize = explode("x", $row["ThumbnailSize"]);

			$row["THUMBNAIL.WIDTH"] = $thumbsize[0];
			$row["THUMBNAIL.HEIGHT"] = $thumbsize[1];

			$row["AUTHOR"] = getUserById($row["AuthorID"]);
			$row["MODIFIED"] = dateFormat($row["LastUpdated"]);

			$row["ACTIONS"] = mkButtonDisplay (
				Array (
					mkLink("index.php/admin/gallery/".$row["ID"], _l("L_EDIT")),
					mkLink("modules/gallery/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1),
					mkLink("modules/gallery/main.act.php?action=".($row["Status"] ? "disable" : "enable")."&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_".($row["Status"] ? "DISABLED" : "ENABLED").""))
				)
			);

			$tpl->set_arr($row);

			$tpl->set_arr (
				Array (
					"BLOCK_ICON" => mkIcon("gallery.png", 16),
					"BLOCK_TITLE" => $row["Title"],
					"BLOCK_SUBTITLE" => _l("L_EDIT_GALLERY"),
					"STATUS.SEL" => mkSelect(Array(_l("L_DISABLED"), _l("L_ENABLED")), $row["Status"], "status"),
					"GALLERIES.SEL" => mkSelect(getGalleries(), $row["GalleryLink"], "gallerylink"),
					"ACTION" => "edit",
					"GALLERIES" => $galleries,
					"RETURN" => ""
				)
			);

			$mcBuff = $tpl->make();

		break;
		default:

			$tpl = new ContentBlock();
			$tpl->insert("BLOCK_CONTENT", "gallery/index.admin.tpl");
			$tpl->insert("GALLERY.FORM", "gallery/gallery.form.tpl");

			$db->query("SELECT
			ID, Title, Description, Status, Thumbnail, ThumbnailSize, AuthorID,
			LastUpdated
			FROM ".db_table("gallery")."
			WHERE GalleryLink = '0' ORDER BY Title ASC", __FILE__, __LINE__);

			$galleries = $db->num_rows();
			while ($row = $db->fetch_row()) {
				$thumbsize = explode("x", $row["ThumbnailSize"]);
				$row["THUMBNAIL.WIDTH"] = $thumbsize[0];
				$row["THUMBNAIL.HEIGHT"] = $thumbsize[1];
				$row["AUTHOR"] = getUserById($row["AuthorID"]);
				$row["MODIFIED"] = dateFormat($row["LastUpdated"]);
				$row["ITEMS"] = countItems($row["ID"]);
				$row["SUBGALLERIES"] = countGalleries($row["ID"]);

				$row["ACTIONS"] = mkButtonDisplay (
					Array (
						mkLink("index.php/admin/gallery/items/".$row["ID"], _l("L_ITEMS")),
						mkLink("index.php/admin/gallery/edit/".$row["ID"], _l("L_EDIT")),
						mkLink("modules/gallery/main.act.php?action=delete&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_DELETE"), false, 1),
						mkLink("modules/gallery/main.act.php?action=".($row["Status"] ? "disable" : "enable")."&id=".$row["ID"]."&auth="._l("C_AUTH_STR")."", _l("L_".($row["Status"] ? "DISABLED" : "ENABLED").""))
					)
				);

				$tpl->set_arr($row, "GALLERY");
				$tpl->saveBuff("GALLERY");
			}

			$tpl->set_arr (
				Array (
					"BLOCK_ICON" => mkIcon("gallery.png", 16),
					"BLOCK_TITLE" => _l("L_GALLERY"),
					"BLOCK_SUBTITLE" => _l("L_CREATE_GALLERY"),
					"STATUS.SEL" => mkSelect(Array(_l("L_DISABLE"), _l("L_ENABLE")), 1, "status"),
					"GALLERIES.SEL" => mkSelect(getGalleries(), 0, "gallerylink"),
					"ACTION" => "create",
					"TITLE" => "",
					"DESCRIPTION" => "",
					"THUMBNAIL" => "",
					"AUTH_ACCESS" => "*",
					"GALLERIES" => $galleries,
					"RETURN" => ""
				)
			);
			$mcBuff = $tpl->make();

		break;
	}

?>