<?php

	/*
	*	Gekko - Open Source Web Development Framework
	*	------------------------------------------------------------------------
	*	Copyright (C) 2004-2005, J. Carlos Nieto <xiam@users.sourceforge.net>
	*	This program is Free Software.
	*
	*	@package	Gekko
	*	@license	http://www.gnu.org/copyleft/gpl.html GNU/GPL License 2.0
	*	@author		J. Carlos Nieto <xiam@users.sf.net>
	*	@version	CVS: $Id:$
	*	@link		http://gekkoware.sourceforge.net
	*/

	if (!defined("IN-GEKKO")) die("Get a life!");

	function imagesize($file) {
		$size = @getimagesize($file);
		if (isset($size[0]) && isset($size[1])) {
			return "{$size[0]}x{$size[1]}";
		}
		return false;
	}

	function get_media_type($media) {
		switch (file_extension($media)) {
			case "jpg": case "jpeg": case "gif": case "png": case "xpm": case "tiff":
				$type = "image";
			break;
			case "swf":
				$type = "flash";
			break;
			default:
				$type = "unknown";
			break;
		}
		return $type;
	}

	function getGalleries($main = true) {

		$return = Array();
		if ($main) $return[0] = "("._l("L_MAIN").")";

		$q = $GLOBALS["db"]->query("SELECT ID, Title FROM ".db_table("gallery")."
		".($main ? "WHERE GalleryLink = '0'":"")."
		ORDER BY Title ASC", __FILE__, __LINE__, true);

		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			saneHTML($row);
			$return[$row["ID"]] = $row["Title"];
		}

		return $return;
	}

	function deleteGallery($id) {
		/* dropping subgalleries */
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("gallery")." WHERE GalleryLink = '{$id}'", __FILE__, __LINE__, true);
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			deleteGallery($row["ID"]);
		}

		/* deleting asociated items */
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("gallery_item")." WHERE GalleryLink = '{$id}'", __FILE__, __LINE__, true);
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			deleteGalleryItem($row["ID"]);
		}

		/* deleting thumbnail */
		$q = $GLOBALS["db"]->query("SELECT Thumbnail FROM ".db_table("gallery")." WHERE ID = '{$id}'", __FILE__, __LINE__, true);
		$r = $GLOBALS["db"]->fetch_row($q);

		/* deleting media source */
		@unlink(GEKKO_ROOT.$row["Thumbnail"]);

		slog("gallery: deleted gallery '$id' with all linked contents", "actions", 1);

		return $GLOBALS["db"]->query ("DELETE FROM ".db_table("gallery")." WHERE ID='{$id}'", __FILE__, __LINE__, true);
	}
	function deleteGalleryItem($id) {
		require_once GEKKO_ROOT."modules/comments/main.lib.php";

		// deleting comments
		deleteComments("gallery", $id);

		$q = $GLOBALS["db"]->query("SELECT Thumbnail, MediaURL FROM ".db_table("gallery_item")." WHERE ID = '{$id}'", __FILE__, __LINE__, true);
		$r = $GLOBALS["db"]->fetch_row($q);

		// deleting media
		@unlink(GEKKO_ROOT.$r["Thumbnail"]);
		@unlink(GEKKO_ROOT.$r["MediaURL"]);

		slog("gallery: deleted galley item '$id'", "actions", 1);

		return $GLOBALS["db"]->query ("DELETE FROM ".db_table("gallery_item")." WHERE ID='{$id}'", __FILE__, __LINE__, true);
	}
	function gallerySetStatus($id, $status) {
		slog("gallery: status of '$id' changed to '$status'", "actions", 2);
		return $GLOBALS["db"]->query ("UPDATE ".db_table("gallery")." SET Status = '{$status}' WHERE ID='{$id}'", __FILE__, __LINE__, true);
	}
	function countGalleries($id = 0) {
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("gallery")."
		WHERE GalleryLink = '{$id}'", __FILE__, __LINE__, true);
		return intval($GLOBALS["db"]->num_rows($q));
	}

	function countItems($id = 0) {
		$q = $GLOBALS["db"]->query("SELECT ID FROM ".db_table("gallery_item")."
		WHERE GalleryLink = '{$id}'", __FILE__, __LINE__, true);

		return intval($GLOBALS["db"]->num_rows($q));
	}
	function galleryAllowComment($thread) {

		// checking item
		$q = $GLOBALS["db"]->query("SELECT GalleryLink FROM ".db_table("gallery_item")." WHERE ID = '".$thread."' AND AllowComments = '1'", __FILE__, __LINE__, true);
		$row = $GLOBALS["db"]->fetch_row($q);

		// checking access
		$q = $GLOBALS["db"]->query("SELECT auth_Access FROM ".db_table("gallery")." WHERE ID = '{$row["GalleryLink"]}' AND Status = '1'");
		$row = $GLOBALS["db"]->fetch_row($q);

		return $GLOBALS["db"]->num_rows($q) ? gauth($row["auth_Access"]) : false;
	}
	function get_allowed_categories($gallerylink = 0, $check_all = false) {
		$allowed = Array();
		$q = $GLOBALS["db"]->query("SELECT ID, auth_Access
		FROM ".db_table("gallery")."
		WHERE ".($check_all ? "" : "GalleryLink = '{$gallerylink}' AND")." Status = '1'", __FILE__, __LINE__, true);
		while ($row = $GLOBALS["db"]->fetch_row($q)) {
			if (gauth($row["auth_Access"])) {
				$allowed[] = $row["ID"];
			}
		}
		return $allowed;
	}

	function gallery_row(&$row, $is_item = false) {
		$row["TITLE_ID"] = urlencode($row["Title"]);

		/* thumbnail size */
		$thumbsize = explode("x", $row["ThumbnailSize"]);
		$row["THUMBNAIL.WIDTH"] = $thumbsize[0];
		$row["THUMBNAIL.HEIGHT"] = $thumbsize[1];

		$row["MODIFIED"] = dateFormat($row["LastUpdated"]);
		$row["AUTHOR"] = getUserById($row["AuthorID"]);

		if (!$is_item) {
			$row["ITEMS"] = countItems($row["ID"]);
			$row["SUBGALLERIES"] = countGalleries($row["ID"]);
		}
	}
?>